package inspector
{
	import flash.display.DisplayObject;
	import flash.utils.describeType;
	import mx.controls.DataGrid;
	import mx.controls.dataGridClasses.DataGridColumn;
	import mx.controls.Alert;

	public class InspectProp extends DataGrid
	{
		public function InspectProp()
		{
			super();
			editable = true;

			// set columns
			var _columns:Array = [];
			var column:DataGridColumn = new DataGridColumn();
			column.dataField = "name";
			column.headerText = "Name";
			column.showDataTips = true;
			column.editable = false;
			_columns.push(column);

			column = new DataGridColumn();
			column.dataField = "value";
			column.headerText = "Value";
			column.showDataTips = true;
			// TODO: editable
			column.editable = false;
			_columns.push(column);
			
			columns = _columns;
		}

		public function show(obj:Object):void
		{
			if(obj == null)
			{
				dataProvider = [];
			}
			
			var xml:XML =  describeType(obj);
			var bindingData:Array = [];

			// get property list
			var props:Array = [];
			for each(var prop:XML in xml.accessor)
			{
				props.push(prop.@name);
			}
			props.sort();

			var name:String;
			for(var i:int = 0; i < props.length; i++)
			{
				if(name == props[i]) continue;
				name = props[i];
				try
				{
					var v:* = obj[name];
					bindingData.push({name : name, value : v ? v.toString() : "null"});
				}
				catch(e:*)
				{
					bindingData.push({name : name, value : e.toString()});
				}
			}

			// get method list
			var methods:Array = [];
			for each(prop in xml.method)
			{
				methods.push({name : prop.@name, declaredBy : prop.@declaredBy});
			}
			methods.sort(function(a:Object, b:Object):int{return a.name > b.name ? 1 : a.name == b.name ? 0 : -1});

			for(i = 0; i < methods.length; i++)
			{
				bindingData.push({name : methods[i].name, value : "method declared by " + methods[i].declaredBy});
			}

			dataProvider = bindingData;
		}
	}
}
