package inspector
{
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.utils.getQualifiedClassName;
	import mx.events.*;
	import mx.controls.*;
	import mx.core.*;
	import mx.binding.utils.*;

	public class InspectTree extends Tree
	{
		private var application : Application;
		private var treeData:Object;

		[Bindable]
		public var target:DisplayObject;

		public function InspectTree()
		{
			super();

			application = Application.application as Application;
			if(application == null)
			{
				showError();
				return;
			}
			application.addEventListener("applicationComplete", complete);

			ChangeWatcher.watch(this, "target", function(e:PropertyChangeEvent):void
			{
				treeData = {};
				dataProvider = treeData;
				trace(e.newValue);
				parseAndAdd(e.newValue as DisplayObject, treeData);
			});

			//dataProvider = [{label : "a", children : []}, {label : "b"}];
			//dataProvider = {label : sm.stage ? sm.stage.toString() : "null"};
		}

		private function complete(e:FlexEvent):void
		{
			if(application.stage == null)
			{
				showError();
				return;
			}

			treeData = {};
			dataProvider = treeData;
			parseAndAdd(target, treeData);

			addEventListener("itemOpening", expanding);
		}

		private function parseAndAdd(dispObj:DisplayObject, bindingObj:Object):void
		{
			var s:String = getQualifiedClassName(dispObj);
			bindingObj.label = s;
			bindingObj.data = dispObj;
			if(dispObj is DisplayObjectContainer)
			{
				bindingObj.children = [];
				bindingObj.loaded = false;
			}
		}

		private function expanding(e:mx.events.TreeEvent):void
		{
			// get opening dispObjCon and bindingObj
			var bindingObj:Object = e.item;
			if(bindingObj == null) return;
			var dispObjCon:DisplayObjectContainer = bindingObj.data as DisplayObjectContainer;
			if(dispObjCon == null) return;
			if(!bindingObj.children)
			{
				bindingObj.children = [];
			}

			// skip if loaded
			if(bindingObj.loaded)
			{
				return;
			}

			// add dispObjCon's children to tree
			for(var i:int = 0; i < dispObjCon.numChildren; i++)
			{
				var child:DisplayObject = dispObjCon.getChildAt(i);
				if(child == parent) continue;

				var o:Object = {};
				parseAndAdd(child, o);
				bindingObj.children.push(o);
			}
			bindingObj.loaded = true;
		}

		private function showError():void
		{
			dataProvider = {label : "failed to inspect"};
		}
	}
}
